com.ihr.xbrl.store.services

## Class RSS_Storage_SEC

- java.lang.Object
- - com.ihr.xbrl.database.common.XBRLDatabaseAccessApp
  - - com.ihr.xbrl.store.StorageService
    - - com.ihr.xbrl.store.services.RSS_Storage_SEC

- All Implemented Interfaces:
    HasEnableDisableOpenMenus, StorageEventListener

      public class RSS_Storage_SEC
      extends StorageService

  This is the new implementation.
  Author:
    Ignacio

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.ihr.xbrl.store.StorageService

      `StorageService.StorageStatus`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `edgarNS` The Constant edgarNS.
    `static org.apache.log4j.Logger` | `log` The log.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RSS_Storage_SEC()` Instantiates a new RS s_ storage_ sec.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.util.Vector<java.lang.String>` | `getRssURIs(java.util.Vector<java.lang.String> rssURIs)` Returns a Vector of String objects with URLs of official pages that are RSS feeds from the SEC containing information about last stored XBRL reports.
    `static void` | `main(java.lang.String[] args)` The main method.
    `void` | `processAddFile(java.lang.String companyName, java.lang.String cik, java.lang.String instanceURL, java.util.Collection<java.lang.String> pArgs, boolean testMode, boolean bInASeparateProcess, StorageEventListener[] listeners)` Process add file.
    `void` | `runService(java.lang.String serviceURI, StorageEventListener[] listeners, boolean bInASeparateProcess)` reads the content of the URL indicated in the first argument and process it according to the format specified by the SEC RSS.

    - ### Methods inherited from class com.ihr.xbrl.store.StorageService

      `clear, disableOpen, documentStoredEvent, doStoreDTS, doStoreDTS, doStoreDTS, enableOpen, getLastMessage, getPercentage, getService, getStackTrace, getStatus, getStorageThreads, getTooltipMessage, isStored`

    - ### Methods inherited from class com.ihr.xbrl.database.common.XBRLDatabaseAccessApp

      `getDbUtil, getStatus, showDbSettings`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### edgarNS

          public static final java.lang.String edgarNS

      The Constant edgarNS.
      See Also:
        Constant Field Values

    - #### log

          public static org.apache.log4j.Logger log

      The log.

  - ### Constructor Detail

    - #### RSS_Storage_SEC

          public RSS_Storage_SEC()

      Instantiates a new RS s_ storage_ sec.

  - ### Method Detail

    - #### main

          public static void main(java.lang.String[] args)

      The main method.
      Parameters:
        `args` - the arguments

    - #### getRssURIs

          public static java.util.Vector<java.lang.String> getRssURIs(java.util.Vector<java.lang.String> rssURIs)

      Returns a Vector of String objects with URLs of official pages that are RSS feeds from the SEC containing information about last stored XBRL reports.
      Parameters:
        `rssURIs` - a Vector of strings with already loaded URLs, the URLs will not be duplicate. If null, a new Vector will be created
      Returns:
        Vector>String<

    - #### runService

          public void runService(java.lang.String serviceURI,
                        StorageEventListener[] listeners,
                        boolean bInASeparateProcess)

      reads the content of the URL indicated in the first argument and process it according to the format specified by the SEC RSS.
      Parameters:
        `serviceURI` - the URL of the file to read
        `listeners` - array of StorageEventListeners that will be informed about the storage result or null if not needed
        `bInASeparateProcess` - the b in a separate process

    - #### processAddFile

          public void processAddFile(java.lang.String companyName,
                            java.lang.String cik,
                            java.lang.String instanceURL,
                            java.util.Collection<java.lang.String> pArgs,
                            boolean testMode,
                            boolean bInASeparateProcess,
                            StorageEventListener[] listeners)

      Process add file.
      Parameters:
        `companyName` - the company name that would be stored in the FriendlyCompanyName table
        `cik` - the identifier part in the entity for this company name
        `instanceURL` - the instance document URL to read and store into the database
        `pArgs` - additional arguments to be added to the background java process if they are required
        `testMode` - boolean, true means nothing will be stored into the database but the DTS will be loaded
        `bInASeparateProcess` - the b in a separate process
        `listeners` - This is an optional array of StorageEventListeners that will be informed when the storage process ends. null means no listeners will be notified